/* GNU polyxmass - the massist's program.
   -------------------------------------- 
   Copyright (C) 2000,2001,2002,2003,2004 Filippo Rusconi

   http://www.polyxmass.org

   This file is part of the "GNU polyxmass" project.
   
   The "GNU polyxmass" project is an official GNU project package (see
   www.gnu.org) released ---in its entirety--- under the GNU General
   Public License and was started at the Centre National de la
   Recherche Scientifique (FRANCE), that granted me the formal
   authorization to publish it under this Free Software License.

   This software is free software; you can redistribute it and/or
   modify it under the terms of the GNU  General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU  General Public
   License along with this software; if not, write to the
   Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/
#ifndef POLYXDEF_UI_FRAGSPECS_H
#define POLYXDEF_UI_FRAGSPECS_H

#include "polyxdef-globals.h"
#include "polyxdef-defctxt.h"



/* columns */
enum
{
  /* fragspecif data */
  COLUMN_FGS_NAME = 0,
  COLUMN_FGS_END,
  COLUMN_FGS_ACTFORM,
  COLUMN_FGS_COMMENT,
  /* fragrule data */
  COLUMN_FGR_NAME,
  COLUMN_FGR_PREV,
  COLUMN_FGR_THIS,
  COLUMN_FGR_NEXT,
  COLUMN_FGR_ACTFORM,
  COLUMN_FGR_COMMENT,

  COLUMN_FGS_VISIBLE,
  COLUMN_FGS_EDITABLE,
  COLUMN_FGS_COL_COUNT
};



gboolean 
polyxdef_ui_polchemdef_wnd_setup_fragspecs_notebook_page (PxmDefCtxt *defctxt,
							  GladeXML *xml);

gboolean
polyxdef_ui_polchemdef_wnd_setup_fragspecs_treeview (PxmDefCtxt *defctxt);

GtkTreeModel *
polyxdef_ui_polchemdef_wnd_create_fragspecs_treeview_model (GPtrArray *
							    fragspecGPA);

void
polyxdef_ui_polchemdef_wnd_fragspecs_cell_edited (GtkCellRendererText *cell,
						  const gchar *path_string,
						  const gchar *new_text,
						  gpointer data);

void
polyxdef_ui_polchemdef_wnd_fragspec_add_fgs_button (GtkWidget *widget,
						    gpointer data);

void
polyxdef_ui_polchemdef_wnd_fragspec_add_fgr_button (GtkWidget *widget, 
						    gpointer data);

void
polyxdef_ui_polchemdef_wnd_fragspec_remove_button (GtkWidget *widget, 
						   gpointer data);










#endif /* #ifndef POLYXDEF_UI_FRAGSPECS_H */
